*DECK EDIHMX
      SUBROUTINE EDIHMX(IPTRK ,NREGIO,NMERGE,IMERGE)
C
C---------------------------  EDIHMX  ---------------------------------
C
C  1- PROGRAMME STATISTICS:
C      NAME     : EDIHMX
C      USE      : FIND MERGE VECTOR IN IPTRK
C                 FOR MERGE BY HMIX
C      MODIFIED : 2001/10/30 (G.M)
C      AUTHOR   : G.MARLEAU
C
C  2- ROUTINE PARAMETERS:
C      IPTRK    : CALCULATION TRACKING DATA STRUCTURE
C                 ***> INTEGER IPTRKI
C      NREGIO   : NUMBER OF REGIONS
C                 ***> INTEGER NREGIO
C      NMERGE   : FINAL NUMBER OF MERGED REGIONS
C                 ***> INTEGER NMERGE
C      IMERGE   : MERGED REGIONS POSITION
C                 ***> INTEGER IMERGE(NREGIO)
C
C---------------------------   EDIHMX  --------------------------------
C
      IMPLICIT    NONE
      INTEGER     IOUT,NSTATE
      CHARACTER   NAMSBR*6
      PARAMETER  (IOUT=6,NSTATE=40,NAMSBR='EDIHMX')
C----
C  ROUTINE PARAMETERS
C----
      INTEGER     IPTRK
      INTEGER     NREGIO
      INTEGER     NMERGE
      INTEGER     IMERGE(NREGIO)
C----
C  LOCAL PARAMETERS
C----
      INTEGER     IMRGLN,IMRGTY,IREG
C----
C  IMERGE is HOMMATCOD or MATCOD
C----
      CALL LCMLEN(IPTRK,'HOMMATCOD   ',IMRGLN,IMRGTY)
      IF(IMRGLN .EQ. 0) THEN
        WRITE(IOUT,8000) NAMSBR
        CALL LCMGET(IPTRK,'MATCOD      ',IMERGE)
      ELSE
        CALL LCMGET(IPTRK,'HOMMATCOD   ',IMERGE)
      ENDIF
      NMERGE=0
      DO IREG=1,NREGIO
        NMERGE=MAX(NMERGE,IMERGE(IREG))
      ENDDO
      RETURN
C----
C  WARNING FORMAT
C----
 8000 FORMAT('***** Warning in routine - ',A6,' - *****'/
     >'No HMIX data in GEO: for NXT tracking file'/
     >'Homogenize using MIX instead of HMIX')
      END
